<ejs-treegrid #treeGrid
              (contextMenuClick)='contextMenuClick($event)'
              (contextMenuOpen)='onHeaderMenuOpen($event)'
              [contextMenuItems]='contextMenuItems'
              [dataSource]='data'
              [treeColumnIndex]='1'
              [sortSettings]='sortSettings'
              childMapping='subtasks'
              [frozenColumns]='frozenColumns'
              [allowReordering]='true'
              [allowRowDragAndDrop]='true'
              [allowResizing]='true'
              [showColumnChooser]='true'
              [allowSorting]='true'
              [height]='height'
              [toolbar]='["ColumnChooser"]'
              [selectionSettings]='{ type: mSelect ? "Multiple" : "Single", enableToggle: false }'
              (resizeStop)='onResize($event)'
              (rowSelected)='onSelectionChange($event)'
              (rowDragStart)='onRowDragStart($event)'
              (rowDrop)='onRowDrop()'
              (columnDrop)='onReorder($event)'
              (actionBegin)='onActionBegin($event)'
              (actionComplete)='onActionEnd($event)'
              [editSettings]='{ allowDeleting: true, allowEditing: true, allowAdding: true, mode: "Dialog" }'
              [allowMultiSorting]='mSort'
              [allowFiltering]='allowFiltering'>
  <e-columns>
    <ng-container *ngFor='let column of columns'>
      <e-column [headerText]='column.headerText'
                [field]='column.name'
                [format]='column.format'
                [isPrimaryKey]='column.isPrimary'
                [minWidth]='column.minWidth'
                [textAlign]='column.textAlign'
                [editType]='column.dataType + "edit"'
                [width]='column.width'>
                <ng-template #headerTemplate>
                  <div class="app-header-cell {{ column.isPrimary ? 'pk' : '' }}" [ngStyle]='{
                    "font-size.px": column.fontSize,
                    "color": column.fontColor,
                    "background-color": column.backgroundColor,
                    "word-wrap": column.textWrap
                  }'>{{ column.headerText }}</div>
                </ng-template>
                <ng-template #template let-data>
                  <div class='app-row-cell' [ngStyle]='{
                    "font-size.px": column.fontSize,
                    "color": column.fontColor,
                    "background-color": getBackgroundColor(data, column),
                    "word-wrap": column.textWrap
                  }'>{{
                    column.dataType === 'datepicker'
                      ? ((data[column.name] || column.defaultValue) | date : 'shortDate')
                      :
                      (data[column.name] || column.defaultValue) }}
                  </div>
                </ng-template>
      </e-column>
    </ng-container>
  </e-columns>
  <ng-template #editSettingsTemplate let-data>
    <form *ngIf='addEditForm'>
        <div class="form-row" *ngFor='let el of columns'>
            <app-input [control]='getAddEditControl(el.name)'
                       [dataType]='el.dataType'
                       [name]='el.name'
                       [label]='el.headerText'
                       [dataSource]='el.dataSource || []'>
            </app-input>
      </div>
    </form>
  </ng-template>
</ejs-treegrid>
<div *ngIf='!modalIsHidden'>
  <app-add-edit-modal #modal></app-add-edit-modal>
</div>
